> For the complete documentation index, see [llms.txt](https://boxlang.ortusbooks.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://boxlang.ortusbooks.com/boxlang-language/reference/built-in-functions/watcher/watchernew.md).

# WatcherNew

Creates and registers a new watcher instance in the watcher service.

The watcher is registered but not started. Call {@code watcherStart( name )} to begin processing filesystem events or {@code start()} on the returned WatcherInstance.

You can register three types of listeners, which BoxLang will automatically wrap into an IWatcherListener implementation:

* {@link Function}: wrapped as a {@code ClosureListener}. Can only handle the {@code onEvent} method.
* {@link IStruct}: wrapped as a {@code StructListener}. Can handle {@code onEvent} and {@code onError} methods.
* {@link String}: treated as a class name and wrapped as a {@code ClassListener}. The class must implement {@code IWatcherListener}.

If {@code name} is omitted or blank, a unique watcher name is auto-generated.

## Method Signature

```
WatcherNew(name=[string], paths=[any], listener=[any], recursive=[boolean], debounce=[long], throttle=[long], atomicWrites=[boolean], delay=[long], errorThreshold=[integer], force=[boolean])
```

### Arguments

| Argument         | Type      | Required | Description                                                                        | Default |
| ---------------- | --------- | -------- | ---------------------------------------------------------------------------------- | ------- |
| `name`           | `string`  | `false`  | Optional watcher name. If blank, an auto-generated name is used.                   |         |
| `paths`          | `any`     | `true`   | A directory path string or an array of directory path strings to watch.            |         |
| `listener`       | `any`     | `true`   | Listener definition: function, struct listener map, or listener class name string. |         |
| `recursive`      | `boolean` | `false`  | Whether to watch subdirectories recursively.                                       | `true`  |
| `debounce`       | `long`    | `false`  | Debounce window in milliseconds.                                                   | `0`     |
| `throttle`       | `long`    | `false`  | Throttle window in milliseconds.                                                   | `0`     |
| `atomicWrites`   | `boolean` | `false`  | Whether atomic write filtering is enabled.                                         | `true`  |
| `delay`          | `long`    | `false`  | Startup delay in milliseconds.                                                     | `0`     |
| `errorThreshold` | `integer` | `false`  | Consecutive listener errors before auto-stop.                                      | `10`    |
| `force`          | `boolean` | `false`  | Whether to replace an existing watcher with the same name.                         | `false` |

## Examples

### Create a new file watcher

```java
w = watcherNew( "myWatcher", getTempDirectory() );
writeOutput( w.getName() );

```

Result: myWatcher

### Watcher with event callback

```java
w = watcherNew( "callbackWatcher", getTempDirectory(), ( event ) => {
    println( event.type() & " on " & event.path() );
} );
writeOutput( isObject( w ) );

```

Result: true

## Related

* [WatcherExists](/boxlang-language/reference/built-in-functions/watcher/watcherexists.md)
* [WatcherGet](/boxlang-language/reference/built-in-functions/watcher/watcherget.md)
* [WatcherGetAll](/boxlang-language/reference/built-in-functions/watcher/watchergetall.md)
* [WatcherList](/boxlang-language/reference/built-in-functions/watcher/watcherlist.md)
* [WatcherRestart](/boxlang-language/reference/built-in-functions/watcher/watcherrestart.md)
* [WatcherShutdown](/boxlang-language/reference/built-in-functions/watcher/watchershutdown.md)
* [WatcherShutdownAll](/boxlang-language/reference/built-in-functions/watcher/watchershutdownall.md)
* [WatcherStart](/boxlang-language/reference/built-in-functions/watcher/watcherstart.md)
* [WatcherStop](/boxlang-language/reference/built-in-functions/watcher/watcherstop.md)
* [WatcherStopAll](/boxlang-language/reference/built-in-functions/watcher/watcherstopall.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://boxlang.ortusbooks.com/boxlang-language/reference/built-in-functions/watcher/watchernew.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
